
BPPlatform subclass: #BPSqueakPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parasol-Squeak'!

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
byteArrayFromBase64String: aString

	^ aString  base64Decoded asByteArray! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
fileDelete: filename
	FileDirectory default deleteFileNamed: filename! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
fileWrite: filenameString contents: aStringOrByteArray

	| file |
	(file := StandardFileStream forceNewFileNamed: filenameString)
		nextPutAll: aStringOrByteArray;
		close.
	^file fullName! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
handleRequest: aBlock

	| response contents|
	response := aBlock value response.
	contents := response contents.
	^(BPHttpResponse new)
		httpStatus: response status ;
		headers: response headers;
		contents: contents;
		yourself! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
httpDelete: url

	^self handleRequest: [ WebClient httpDelete: url asString ]! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
httpGet: url

	^self handleRequest: [ WebClient httpGet: url asString ]! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
httpPost: url data: data timeout: seconds
	 | data2 |
	data2 := (ZnEntity with: data
				type: (WAMimeType main: 'application' sub: 'json'))
				setCharSetUTF8;
				yourself.
	^self handleRequest: [ WebClient httpDo: [:client | 
		client 
			timeout: seconds;
			httpPost: url asString content: data2 type: 
				(WAMimeType applicationJson greaseString)] ]! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
isMacOSX
	^ OSPlatform current isMacOSX! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
jsonRead: aString 
	^JSJsonParser parse: aString! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/19/2014 14:54'!
jsonWrite: anObject

	| stream |
	stream := WriteStream on: String new.
	anObject jsonWriteOn: stream.
	^stream contents! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
name
	^'Squeak'! !

!BPSqueakPlatform methodsFor: 'facade' stamp: 'haerle 8/20/2014 09:26'!
port
	| adaptors |
	adaptors := WAAdmin serverAdaptors .
	^ adaptors isEmpty 
		ifTrue: [8080] 	" lets hardcode.. "
		ifFalse: [adaptors first port]! !
